

local fontId
Citizen.CreateThread(function()
	Citizen.Wait(1000)
	RegisterFontFile('wmk')
	fontId = RegisterFontId('Freedom Font')
end)

local function drawHudText(x,y ,width,height,scale, text, r,g,b,a, outline, font, center)
    SetTextFont(fontId)
    SetTextProportional(0)
    SetTextScale(scale, scale)
    SetTextColour(r, g, b, a)
    SetTextDropShadow(0, 0, 0, 0,255)
    SetTextEdge(1, 0, 0, 0, 255)
    SetTextDropShadow()
    SetTextCentre(center)
    if(outline)then
        SetTextOutline()
    end
    SetTextEntry("STRING")
    AddTextComponentString(text)
    DrawText(x - width/2, y - height/2 + 0.005)

end

local function job_DisplayHelpText(str)
	SetTextComponentFormat("STRING")
	AddTextComponentString(str)
	DisplayHelpTextFromStringLabel(0, 0, 1, -1)
end

local function DrawText3D(x,y,z, text, scl) 

    local onScreen,_x,_y=World3dToScreen2d(x,y,z)
    local px,py,pz=table.unpack(GetGameplayCamCoords())
    local dist = GetDistanceBetweenCoords(px,py,pz, x,y,z, 1)
 
    local scale = (1/dist)*scl
    local fov = (1/GetGameplayCamFov())*100
    local scale = scale*fov
   
    if onScreen then
        SetTextScale(0.0*scale, 1.1*scale)
        SetTextFont(0)
        SetTextProportional(1)
        SetTextColour(255, 255, 255, 255)
        SetTextDropshadow(0, 0, 0, 0, 255)
        SetTextEdge(2, 0, 0, 0, 150)
        SetTextDropShadow()
        SetTextOutline()
        SetTextEntry("STRING")
        SetTextCentre(1)
        AddTextComponentString(text)
        DrawText(_x,_y)
    end
end

local function job_drawTxt(text,font,centre,x,y,scale,r,g,b,a)
	SetTextFont(font)
	SetTextProportional(0)
	SetTextScale(scale, scale)
	SetTextColour(r, g, b, a)
	SetTextDropShadow(0, 0, 0, 0,255)
	SetTextEdge(1, 0, 0, 0, 255)
	SetTextDropShadow()
	SetTextOutline()
	SetTextCentre(centre)
	SetTextEntry("STRING")
	AddTextComponentString(text)
	DrawText(x, y)
end

CarSpawnLocs = nil
CarStopsLocs = nil
theBlips = {}
CarStopsBlip = nil
theCar = nil
hasCarRouteStarted = false
CarCheckpoint = 0
atCarStop = false
finishCarRoute = {}
finishBlip = nil
CarBlip = nil
CarStopsBlip2 = nil


function tvRP.CarPopulateData(CarSpawns, CarLocs, finishTrash)
	CarSpawnLocs = CarSpawns
	CarStopsLocs = CarLocs
	finishCarRoute = finishTrash
	SetNewWaypoint(CarSpawnLocs[1][1], CarSpawnLocs[1][2])
end

function tvRP.deleteTheCar()
	if(DoesEntityExist(theCar))then
		Citizen.InvokeNative(0xEA386986E786A54F, Citizen.PointerValueIntInitialized(theCar))
		theCar = nil
	end
end

function tvRP.spawnTheCarttt()
	if(theCar == nil)then
		coords = GetEntityCoords(PlayerPedId(), true)
		vehicle = GetHashKey("felon")
		RequestModel(vehicle)
		while not HasModelLoaded(vehicle) do
			Citizen.Wait(0)
		end
		theCar = CreateVehicle(vehicle, coords.x, coords.y, coords.z+0.5, 213.70028686523, true, false)
		SetVehicleOnGroundProperly(theCar)
		SetEntityInvincible(theCar, false)
		SetPedIntoVehicle(PlayerPedId(), theCar, -1)
		Citizen.InvokeNative(0xAD738C3085FE7E11, theCar, true, true) -- set as mission entity
		SetVehicleHasBeenOwnedByPlayer(theCar, true)
		SetModelAsNoLongerNeeded(vehicle)
	end
end

function tvRP.startCarRoute()
	hasCarRouteStarted = true
	for i, v in pairs(theBlips) do
		if(DoesBlipExist(v))then
			RemoveBlip(v)
			theBlips[i] = nil
		end
	end
	tvRP.nextCarStop()
	vRPserver.gulugulu()
	tvRP.notify("[DMV] Urmeaza ruta!")
end

function tvRP.nextCarStop()
	CarCheckpoint = CarCheckpoint + 1
	if(CarStopsLocs[CarCheckpoint][4] == true)then
		blipColor = 1
	else
		blipColor = 2
	end
	if(CarStopsBlip == nil) or (DoesBlipExist(CarStopsBlip))then
		if(DoesBlipExist(CarStopsBlip))then
			RemoveBlip(CarStopsBlip)
		end
		CarStopsBlip = AddBlipForCoord(CarStopsLocs[CarCheckpoint][1], CarStopsLocs[CarCheckpoint][2], CarStopsLocs[CarCheckpoint][3])
		SetBlipRoute(CarStopsBlip, true)
		SetBlipSprite(CarStopsBlip, 270)
		SetBlipColour(CarStopsBlip, blipColor)
		SetBlipRouteColour(CarStopsBlip, 2)
	end
	if(CarCheckpoint+1 <= #CarStopsLocs)then
		if(CarStopsBlip2 == nil) or (DoesBlipExist(CarStopsBlip2))then
			if(DoesBlipExist(CarStopsBlip2))then
				RemoveBlip(CarStopsBlip2)
			end
			CarStopsBlip2 = AddBlipForCoord(CarStopsLocs[CarCheckpoint+1][1], CarStopsLocs[CarCheckpoint+1][2], CarStopsLocs[CarCheckpoint+1][3])
			SetBlipSprite(CarStopsBlip2, 270)
			SetBlipColour(CarStopsBlip2, 16)
		end
	end
end

function tvRP.stopCarRoute()
	hasCarRouteStarted = false
	tvRP.notify("[DMV] Ai anulat Testul!")
	CarCheckpoint = 0
	if(DoesBlipExist(CarStopsBlip))then
		RemoveBlip(CarStopsBlip)
		CarStopsBlip = nil
	end
	if(DoesBlipExist(CarStopsBlip2))then
		RemoveBlip(CarStopsBlip2)
		CarStopsBlip2 = nil
	end
	if(DoesBlipExist(CarBlip))then
		RemoveBlip(CarBlip)
		CarBlip = nil
	end
	if(DoesBlipExist(finishBlip))then
		RemoveBlip(finishBlip)
		finishBlip = nil
	end
	vRPserver.stopCarRoute({})
	atCarStop = false
end

function tvRP.finishCarRoute(route)
	hasCarRouteStarted = false
	CarCheckpoint = 0
	if(DoesBlipExist(CarStopsBlip))then
		RemoveBlip(CarStopsBlip)
		CarStopsBlip = nil
	end
	if(DoesBlipExist(CarStopsBlip2))then
		RemoveBlip(CarStopsBlip2)
		CarStopsBlip2 = nil
	end
	if(DoesBlipExist(CarBlip))then
		RemoveBlip(CarBlip)
		CarBlip = nil
	end
	if(DoesBlipExist(finishBlip))then
		RemoveBlip(finishBlip)
		finishBlip = nil
	end
	atCarStop = false
	tvRP.deleteTheCar()
	vRPserver.daipermisulafraier({route})
	vRPserver.gulugulu()
end

function tvRP.stopAtCarStop(isCarStop)
	if(isCarStop == false)then
		tvRP.nextCarStop()
	else
		if(atCarStop == false)then
			atCarStop = true
			tvRP.notify("[DMV] Asteapta la semafor pana se face verde!")
			SetTimeout(10000, function()
				if(atCarStop)then
					atCarStop = false
					if(#CarStopsLocs > CarCheckpoint)then
						tvRP.nextCarStop()
						tvRP.notify("[DMV] S-a facut verde, poti sa mergi mai departe")
					else
						if(DoesBlipExist(CarStopsBlip))then
							RemoveBlip(CarStopsBlip)
							CarStopsBlip = nil
						end
						tvRP.notify("[DMV] Bravo, intoarce-te de unde ai venit pentru a termina Testul!")
					end
				else
					tvRP.notify("[DMV] Trebuie sa astepti la rosu!")
				end
			end)
		end
	end
end

Citizen.CreateThread(function()
	while true do
		timeTRF = 500
		local ped = PlayerPedId()	
		local pos = GetEntityCoords(ped, true)	
		if((not DoesEntityExist(theCar)) or (IsEntityDead(theCar))) and (hasCarRouteStarted)then
			tvRP.stopCarRoute()
			theCar = nil
		end
		if(atCarStop)then
			timeTRF = 0
			job_drawTxt("~HUD_COLOUR_NET_PLAYER13~[DMV] ~HUD_COLOUR_NET_PLAYER13~Stai la rosu...",1,1,0.5,0.8,0.8,255,255,255,255)
		end
		if(theCar ~= nil)then
			timeTRF = 0
			if(GetVehiclePedIsIn(ped, false) == theCar) and (GetPedInVehicleSeat(theCar, -1) == ped) then
				
				if(hasCarRouteStarted == false)then
					tvRP.startCarRoute()
				end
				if(tonumber(#CarStopsLocs) > tonumber(CarCheckpoint))then
					if(#CarStopsLocs >= CarCheckpoint+1)then
						if(CarStopsLocs[CarCheckpoint+1][4] == true)then
							DrawMarker(1, CarStopsLocs[CarCheckpoint+1][1], CarStopsLocs[CarCheckpoint+1][2], CarStopsLocs[CarCheckpoint+1][3]-1.0, 0, 0, 0, 0, 0, 0, 2.0, 2.0, 200.0, 0, 255, 0, 180, 0, 0, 0, 0)
						else
							DrawMarker(1, CarStopsLocs[CarCheckpoint+1][1], CarStopsLocs[CarCheckpoint+1][2], CarStopsLocs[CarCheckpoint+1][3]-1.0, 0, 0, 0, 0, 0, 0, 2.0, 2.0, 200.0, 255, 255, 0, 180, 0, 0, 0, 0)
						end
					end
					if(CarStopsLocs[CarCheckpoint][4] == true)then
						DrawMarker(1, CarStopsLocs[CarCheckpoint][1], CarStopsLocs[CarCheckpoint][2], CarStopsLocs[CarCheckpoint][3]-1.0, 0, 0, 0, 0, 0, 0, 5.0, 5.0, 200.0, 0, 255, 0, 180, 0, 0, 0, 0)
						if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, CarStopsLocs[CarCheckpoint][1], CarStopsLocs[CarCheckpoint][2], CarStopsLocs[CarCheckpoint][3], true) < 8.0)then
							if(atCarStop == false)then
								tvRP.stopAtCarStop(true)
							end
						else
							atCarStop = false
						end
					else
						DrawMarker(1, CarStopsLocs[CarCheckpoint][1], CarStopsLocs[CarCheckpoint][2], CarStopsLocs[CarCheckpoint][3]-1.0, 0, 0, 0, 0, 0, 0, 5.0, 5.0, 200.0, 255, 255, 0, 180, 0, 0, 0, 0)
						if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, CarStopsLocs[CarCheckpoint][1], CarStopsLocs[CarCheckpoint][2], CarStopsLocs[CarCheckpoint][3], true) < 8.0)then
							tvRP.stopAtCarStop(false)
						end
					end
				end
				if(CarCheckpoint == #CarStopsLocs)then
					if(finishBlip == nil)then
						finishBlip = AddBlipForCoord(finishCarRoute[1], finishCarRoute[2], finishCarRoute[3])
						SetBlipSprite(finishBlip, 270)
						SetBlipColour(finishBlip, 15)
						SetBlipAsShortRange(finishBlip, false)
					end
					DrawMarker(1, finishCarRoute[1], finishCarRoute[2], finishCarRoute[3]-1.0, 0, 0, 0, 0, 0, 0, 5.0, 5.0, 200.0, 0, 255, 0, 180, 0, 0, 0, 0)
					if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, finishCarRoute[1], finishCarRoute[2], finishCarRoute[3], true) < 5.0)then
						job_DisplayHelpText("~w~[~HUD_COLOUR_NET_PLAYER13~E~w~] pentru a termina Testul")
						if(IsControlJustReleased(1, 51))then
							facutetst = true
							tvRP.finishCarRoute(CarCheckpoint)
						end
					end
				end
				if(DoesBlipExist(CarBlip))then
					RemoveBlip(CarBlip)
					CarBlip = nil
				end
			else
				job_drawTxt("~HUD_COLOUR_NET_PLAYER13~[DMV] ~r~Intoarce-te in masina pentru a continua",1,1,0.5,0.8,0.8,255,255,255,255)
				if(CarBlip == nil)then
					CarBlip = AddBlipForEntity(theCar)
					SetBlipSprite(CarBlip, 67)
					SetBlipColour(CarBlip, 1)
					SetBlipAsShortRange(CarBlip, false)
				end
			end
		else
			if(hasCarRouteStarted)then
				timeTRF = 0
				tvRP.stopCarRoute()
			end
			if(CarSpawnLocs ~= nil)then
				timeTRF = 0
				for i, v in pairs(CarSpawnLocs) do
					if(theBlips[i] == nil)then
						theBlips[i] = AddBlipForCoord(v[1], v[2], v[3])
						SetBlipSprite(theBlips[i], 67)
						SetBlipColour(theBlips[i], 2)
						SetBlipAsShortRange(theBlips[i], true)
					end
					if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, v[1], v[2], v[3], true) < 30.0)then
						DrawText3D(v[1], v[2], v[3]+0.1, "~HUD_COLOUR_NET_PLAYER13~[E] Masina", 1.2)
						DrawMarker(39, v[1], v[2], v[3]-0.5, 0, 0, 0, 0, 0, 0, 0.7, 0.7, 0.7, 240,200,80, 255, 0, 0, 0, 1)
						if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, v[1], v[2], v[3], true) < 2.0)then
							job_DisplayHelpText("~w~[~HUD_COLOUR_NET_PLAYER13~E~w~] pentru a incepe testul ~HUD_COLOUR_NET_PLAYER13~DMV")
							if(IsControlJustReleased(1, 51))then
								vRPserver.spawnThecCar({})
							end
						end
					end
				end
			end
		end
		Wait(timeTRF)
	end
end)

facutetst = false

RegisterNetEvent('vezidacaarepermisvere')
AddEventHandler('vezidacaarepermisvere', function(are)
	if are == 0 then
		facutetst = true
	elseif are == 1 then
		facutetst = false
	end
end)

function DrawMissionText2(m_text, showtime)
    ClearPrints()
	SetTextEntry_2("STRING")
	AddTextComponentString(m_text)
	DrawSubtitleTimed(showtime, 1)
end

local seTermina = false
local incepe = false
local alphaaa = 0

function paaaaaa()
	seTermina = true
    Citizen.CreateThread(function()
        while seTermina do
            Citizen.Wait(1)
			if alphaaa <= 0 then
				alphaaa = 0
			else
				alphaaa = alphaaa-1
			end
			if(alphaaa == 0)then
				seTermina = false
			end
        end
    end)
end

function bunaaaaaa()
	incepe = true
    Citizen.CreateThread(function()
        while incepe do
            Citizen.Wait(1)
			if alphaaa < 254 then
				alphaaa = alphaaa + 2
			end
			if alphaaa >= 254 then
				SetTimeout(10000,function()
					incepe = false
					paaaaaa()
				end)
			end
        end
    end)
end

function incepetextul()
    print("Bun Venit!") 
    end
Citizen.CreateThread(function()
    while true do
        if(IsPedInAnyVehicle(PlayerPedId(), false)) and not facutetst then
            incepetextul() 
        end
        Wait(60000)  
    end
end)



